export declare type DocumentLoader = {
    isSupported: (source: string) => boolean;
    loadDocument: (source: string) => Promise<DocumentLoaderResult>;
    loadMetadata: (source: string) => Promise<DocumentMetadata>;
};

export declare type DocumentLoaderResult = {
    content: string;
    metadata: DocumentMetadata;
};

export declare type DocumentMetadata = {
    url: string;
    title: string;
    lastModified?: Date;
};

export declare const googleDocsLoader: DocumentLoader;

export declare const googleDriveLoader: DocumentLoader;

export declare const googleSlidesLoader: DocumentLoader;

export declare function loadDocument(source: string): Promise<DocumentLoaderResult>;

export declare function loadDocumentMetadata(source: string): Promise<DocumentMetadata>;

export declare const notionLoader: DocumentLoader;

export declare const notionPdfBlockLoader: DocumentLoader;

export declare function registerLoader(loader: DocumentLoader): void;

export { }
